Attribute VB_Name = "MAltTab"
Option Explicit

Private Declare Function GetTopWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetNextWindow Lib "user32" Alias "GetWindow" (ByVal hWnd As Long, ByVal wFlag As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function IsWindowVisible Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function GetClassLong Lib "user32" Alias "GetClassLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function IsIconic Lib "user32" (ByVal hWnd As Long) As Long

' GetWindow flags
Private Const GW_HWNDFIRST = 0
Private Const GW_HWNDNEXT = 2

' GetWindowLong flags
Private Const GWL_STYLE = (-16)
Private Const GWL_HWNDPARENT = (-8)

' Window styles
Private Const WS_OVERLAPPED = &H0&
Private Const WS_CAPTION = &HC00000
Private Const WS_SYSMENU = &H80000
Private Const WS_THICKFRAME = &H40000
Private Const WS_MINIMIZEBOX = &H20000
Private Const WS_MAXIMIZEBOX = &H10000

' Common window styles
Private Const WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX)

Public Sub DumpTabOrder()
   Dim hWnd As Long
   Dim Caption As String
   Dim ClassName As String
   Dim dwStyle As Long
   Dim nLen As Long
   Dim ValidTask As Boolean
   Const MAX_LEN = 1024
   
   ' Reset variables
   Caption = Space$(MAX_LEN)
   ClassName = Space$(MAX_LEN)
   ' Grab first window
   hWnd = GetTopWindow(0)
   Do While hWnd
      ' Assume it's not a valid task window.
      ValidTask = False
      ' Get this window's style bits
      dwStyle = GetWindowLong(hWnd, GWL_STYLE)
      
      ' Make sure window is visible and ownerless
      If IsWindowVisible(hWnd) Then
         If GetParent(hWnd) = 0 Then
            If GetWindowLong(hWnd, GWL_HWNDPARENT) = 0 Then
               ' This is probably a good one, but we
               ' need a caption to be sure.
               nLen = GetWindowText(hWnd, Caption, MAX_LEN)
               If nLen Then
                  ValidTask = True
   
                  ' Weed out tooltips -- special case
                  Call GetClassName(hWnd, ClassName, Len(ClassName))
                  If InStr(Caption, "VBBubble") = 1 Then
                     ValidTask = False
                  End If
   
                  ' Desktop window given Progman classname
                  ' to keep older apps from failing
                  If InStr(ClassName, "Progman") = 1 Then
                     If (dwStyle And WS_OVERLAPPEDWINDOW) = 0 Then
                        ValidTask = False
                     End If
                  End If
               End If
            End If
         End If
      End If
      
      ' Do what you need to here.
      If ValidTask Then
         Debug.Print "hWnd: &h" & Hex(hWnd) & _
            ", " & Left$(Caption, nLen)
      End If
      
      ' Get next window and move on
      hWnd = GetNextWindow(hWnd, GW_HWNDNEXT)
   Loop
End Sub

