VERSION 5.00
Begin VB.Form frmTabOrder 
   Caption         =   "Windows Alt+Tab Order Demo"
   ClientHeight    =   4185
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6840
   Icon            =   "TabOrder.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4185
   ScaleWidth      =   6840
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   1080
      Top             =   300
   End
   Begin VB.PictureBox Picture2 
      AutoRedraw      =   -1  'True
      Height          =   495
      Left            =   120
      ScaleHeight     =   435
      ScaleWidth      =   6495
      TabIndex        =   2
      Top             =   3480
      Width           =   6555
   End
   Begin VB.PictureBox Picture1 
      Height          =   675
      Index           =   0
      Left            =   240
      ScaleHeight     =   615
      ScaleWidth      =   615
      TabIndex        =   1
      Top             =   180
      Visible         =   0   'False
      Width           =   675
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Refresh Alt+Tab Display"
      Height          =   495
      Left            =   4440
      TabIndex        =   0
      Top             =   180
      Width           =   2295
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Label1"
      Height          =   195
      Left            =   180
      TabIndex        =   3
      Top             =   3240
      Width           =   480
   End
End
Attribute VB_Name = "frmTabOrder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *************************************************************************
'  Copyright 1999 Karl E. Peterson
'  All Rights Reserved, http://www.mvps.org/vb
' *************************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code, non-compiled, without prior written consent.
' *************************************************************************
Option Explicit

Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function DrawIcon Lib "user32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal hIcon As Long) As Long
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer

Private Const SM_CXICON = 11
Private Const SM_CYICON = 12
Private Const VK_LBUTTON = &H1

Private Const m_Margin = 10 'pixels

Private m_tasks As CTaskList
Private m_MouseDown As Boolean

' ************************************************
'  Event Procedures
' ************************************************
Private Sub Command1_Click()
   ' Refresh task list for display
   Call RefreshTaskList(True)
End Sub

Private Sub Form_Load()
   ' Size picture box to fit large icon
   With Picture1(0)
      .Width = GetSystemMetrics(SM_CXICON) * Screen.TwipsPerPixelX
      .Height = GetSystemMetrics(SM_CYICON) * Screen.TwipsPerPixelY
   End With
   ' Set font to bold for caption display
   Picture2.Font.Bold = True
   ' Provide instructions to user
   Label1.Caption = "Wave mouse over icons for window captions. Click icon to activate that app."
End Sub

Private Sub Form_Paint()
   ' We were probably just uncovered, best to
   ' refresh the task list so it's current.
   ' But only if mouse button isn't down.
   If GetKeyState(VK_LBUTTON) >= 0 Then
      On Error Resume Next
      Call RefreshTaskList
      On Error GoTo 0
   End If
End Sub

Private Sub Form_Resize()
   Dim margin As Long
   ' Position all controls as needed
   On Error Resume Next
   margin = m_Margin * Screen.TwipsPerPixelX
   Command1.Move Me.ScaleWidth - Command1.Width - margin
   Picture2.Move margin, Me.ScaleHeight - Picture2.Height - margin, Me.ScaleWidth - (margin * 2)
   Label1.Top = Picture2.Top - Label1.Height - (Screen.TwipsPerPixelY * 3)
   Call ArrangePictureBoxes
   Picture2.ZOrder
End Sub

Private Sub Picture1_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
   Static LastIndex As Integer
   Dim Caption As String
   
   ' Display caption of window under mouse,
   ' but only if different than what's there.
   If Index <> LastIndex Then
      Caption = m_tasks.Caption(Index)
      With Picture2
         .Cls
         .CurrentX = m_Margin * Screen.TwipsPerPixelX
         .CurrentY = (.ScaleHeight - .TextHeight(Caption)) \ 2
         Picture2.Print Caption
      End With
   End If
End Sub

Private Sub Picture1_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
   ' Activate selected app
   m_tasks.Activate Index
   ' Refresh task list since order just changed
   Call RefreshTaskList
End Sub

Private Sub Timer1_Timer()
   ' Refresh task list in case order changed
   Call RefreshTaskList
End Sub

' ************************************************
'  Private Methods
' ************************************************
Private Sub RefreshTaskList(Optional DebugDump As Boolean = False)
   Dim i As Long
   
   Set m_tasks = New CTaskList
   With m_tasks
      ' Load class with current Alt+Tab data
      .Refresh
      ' Arrange array of picture boxes to hold icons
      LoadPictureBoxes (.Count)
      ' Paint icons for all tasks
      For i = 1 To .Count
         Picture1(i).Cls
         Call DrawIcon(Picture1(i).hDC, 0, 0, .hIcon(i))
         Picture1(i).ToolTipText = "hWnd: &h" & Hex(.hWnd(i))
         
         If DebugDump Then
            Debug.Print "hWnd: &h"; Hex(.hWnd(i)); " -- "; .Caption(i)
         End If
      Next i
   End With
End Sub

Private Sub LoadPictureBoxes(ByVal Num As Long)
   Dim i As Long
   
   If Num > Picture1.UBound Then
      ' Add more picture boxes if we don't have enough
      For i = Picture1.UBound + 1 To Num
         Load Picture1(i)
         With Picture1(i)
            .AutoRedraw = True
            .BorderStyle = 0 'None
            .Left = -(.Width * 2)
            .Visible = True
         End With
      Next i
   
   ElseIf Num < Picture1.UBound Then
      ' Remove picture boxes if we have too many
      For i = Picture1.UBound To (Num + 1) Step -1
         Unload Picture1(i)
      Next i
   End If
   
   ' Make sure they're all nicely arranged
   Call ArrangePictureBoxes
End Sub

Private Sub ArrangePictureBoxes()
   Dim i As Long
   Dim X As Long, Y As Long
   Dim margin As Long
   Dim maxwidth As Long
   
   margin = m_Margin * Screen.TwipsPerPixelX
   maxwidth = Me.ScaleWidth - Command1.Width - (margin * 2)
   
   X = margin
   Y = margin
   For i = 1 To Picture1.UBound
      With Picture1(i)
         .Move X, Y
         X = X + .Width + margin
         If (X + .Width) > maxwidth Then
            X = margin
            Y = Y + .Height + margin
         End If
      End With
   Next i
End Sub

